﻿using System;
using Wisej.Web;

namespace CustomDGVColumn
{
	public class DataGridViewThreeTextBoxColumn : DataGridViewColumn
	{
		public DataGridViewThreeTextBoxColumn()
				: base(new DataGridViewThreeTextBoxCell())
		{
		}

		public class DataGridViewThreeTextBoxCell : DataGridViewCell
		{
			public DataGridViewThreeTextBoxCell()
			{
				this.Control = new ThreeTextBox()
				{
					Dock = DockStyle.Fill
				};
			}

			public override Type ValueType
			{
				get { return typeof(Person); }
				set { }
			}

			public override Type FormattedValueType
			{
				get { return typeof(Person); }
			}

			protected override object GetValue()
			{
				var person = (Person) base.GetValue();

				// Anytime the value is requested it updates the text in the textboxes
				((ThreeTextBox)this.Control).setTextBox1(person.firstName);
				((ThreeTextBox)this.Control).setTextBox2(person.lastName);
				((ThreeTextBox)this.Control).setTextBox3(person.age.ToString());

				return base.GetValue();
			}
		}
	}
}